org.jgroups.blocks

## Class NotificationBus

- java.lang.Object
- - org.jgroups.blocks.NotificationBus

- All Implemented Interfaces:
    MembershipListener, MessageListener, Receiver

  Deprecated.
  Will be pulled in 3.0, use a JChannel directly instead

      @Deprecated
      public class NotificationBus
      extends java.lang.Object
      implements Receiver

  This class provides notification sending and handling capability. Producers can send notifications to all registered consumers. Provides hooks to implement shared group state, which allows an application programmer to maintain a local cache which is replicated by all instances. NotificationBus sits on top of a channel, however it creates its channel itself, so the application programmers do not have to provide their own channel.
  Author:
    Bela Ban

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `NotificationBus.Consumer` Deprecated.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Log` | `log` Deprecated.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NotificationBus()` Deprecated.
    `NotificationBus(Channel channel, java.lang.String bus_name)` Deprecated.
    `NotificationBus(java.lang.String bus_name)` Deprecated.
    `NotificationBus(java.lang.String bus_name, java.lang.String properties)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `block()` Deprecated. Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages.
    `java.io.Serializable` | `getCache()` Deprecated.
    `java.io.Serializable` | `getCacheFromCoordinator(long timeout, int max_tries)` Deprecated. Determines the coordinator and asks it for its cache.
    `java.io.Serializable` | `getCacheFromMember(Address mbr, long timeout, int max_tries)` Deprecated. Determines the coordinator and asks it for its cache.
    `Channel` | `getChannel()` Deprecated. Answers the Channel.
    `Address` | `getLocalAddress()` Deprecated.
    `java.util.Vector` | `getMembership()` Deprecated. Returns a reference to the real membership: don't modify.
    `byte[]` | `getState()` Deprecated. Answers the group state; e.g., when joining.
    `boolean` | `isCoordinator()` Deprecated.
    `void` | `notifyConsumer(java.io.Serializable n)` Deprecated. Don't multicast this to all members, just apply it to local consumers.
    `void` | `receive(Message msg)` Deprecated. Called when a message is received.
    `void` | `sendNotification(Address dest, java.io.Serializable n)` Deprecated. Pack the argument in a Info, serialize that one into the message buffer and send the message
    `void` | `sendNotification(java.io.Serializable n)` Deprecated. Pack the argument in a Info, serialize that one into the message buffer and send the message
    `void` | `setConsumer(NotificationBus.Consumer c)` Deprecated.
    `void` | `setState(byte[] state)` Deprecated. Sets the group state; e.g., when joining.
    `void` | `start()` Deprecated.
    `void` | `stop()` Deprecated.
    `void` | `suspect(Address suspected_mbr)` Deprecated. Called whenever a member is suspected of having crashed, but has not yet been excluded.
    `void` | `viewAccepted(View new_view)` Deprecated. Called when a change in membership has occurred.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### log

          protected final Log log

      Deprecated.

  - ### Constructor Detail

    - #### NotificationBus

          public NotificationBus()
                          throws java.lang.Exception

      Deprecated.
      Throws:
        `java.lang.Exception`

    - #### NotificationBus

          public NotificationBus(java.lang.String bus_name)
                          throws java.lang.Exception

      Deprecated.
      Throws:
        `java.lang.Exception`

    - #### NotificationBus

          public NotificationBus(java.lang.String bus_name,
                         java.lang.String properties)
                          throws java.lang.Exception

      Deprecated.
      Throws:
        `java.lang.Exception`

    - #### NotificationBus

          public NotificationBus(Channel channel,
                         java.lang.String bus_name)
                          throws java.lang.Exception

      Deprecated.
      Throws:
        `java.lang.Exception`

  - ### Method Detail

    - #### setConsumer

          public void setConsumer(NotificationBus.Consumer c)

      Deprecated.

    - #### getLocalAddress

          public Address getLocalAddress()

      Deprecated.

    - #### getMembership

          public java.util.Vector getMembership()

      Deprecated.
      Returns a reference to the real membership: don't modify. If you need to modify, make a copy first !
      Returns:
        Vector of Address objects

    - #### getChannel

          public Channel getChannel()

      Deprecated.
      Answers the Channel. Used to operate on the underlying channel directly, e.g. perform operations that are not provided using only NotificationBus. Should be used sparingly.
      Returns:
        underlying Channel

    - #### isCoordinator

          public boolean isCoordinator()

      Deprecated.

    - #### start

          public void start()
                     throws java.lang.Exception

      Deprecated.
      Throws:
        `java.lang.Exception`

    - #### stop

          public void stop()

      Deprecated.

    - #### sendNotification

          public void sendNotification(java.io.Serializable n)

      Deprecated.
      Pack the argument in a Info, serialize that one into the message buffer and send the message

    - #### sendNotification

          public void sendNotification(Address dest,
                              java.io.Serializable n)

      Deprecated.
      Pack the argument in a Info, serialize that one into the message buffer and send the message

    - #### getCacheFromCoordinator

          public java.io.Serializable getCacheFromCoordinator(long timeout,
                                                     int max_tries)

      Deprecated.
      Determines the coordinator and asks it for its cache. If there is no coordinator (because we are first member), null will be returned. Used only internally by NotificationBus.
      Parameters:
        `timeout` - Max number of msecs until the call returns
        `max_tries` - Max number of attempts to fetch the cache from the coordinator

    - #### getCacheFromMember

          public java.io.Serializable getCacheFromMember(Address mbr,
                                                long timeout,
                                                int max_tries)

      Deprecated.
      Determines the coordinator and asks it for its cache. If there is no coordinator (because we are first member), null will be returned. Used only internally by NotificationBus.
      Parameters:
        `mbr` - The address of the member from which to fetch the state. If null, the current coordinator will be asked for the state
        `timeout` - Max number of msecs until the call returns - if timeout elapses null will be returned
        `max_tries` - Max number of attempts to fetch the cache from the coordinator (will be set to 1 if < 1)

    - #### notifyConsumer

          public void notifyConsumer(java.io.Serializable n)

      Deprecated.
      Don't multicast this to all members, just apply it to local consumers.

    - #### receive

          public void receive(Message msg)

      Deprecated.
      Description copied from interface: `MessageListener`
      Called when a message is received.
      Specified by:
        `receive` in interface `MessageListener`

    - #### getState

          public byte[] getState()

      Deprecated.
      Description copied from interface: `MessageListener`
      Answers the group state; e.g., when joining.
      Specified by:
        `getState` in interface `MessageListener`
      Returns:
        byte[]

    - #### setState

          public void setState(byte[] state)

      Deprecated.
      Description copied from interface: `MessageListener`
      Sets the group state; e.g., when joining.
      Specified by:
        `setState` in interface `MessageListener`

    - #### viewAccepted

          public void viewAccepted(View new_view)

      Deprecated.
      Description copied from interface: `MembershipListener`
      Called when a change in membership has occurred. No long running actions or sending of messages should be done in this callback. If some long running action needs to be performed, it should be done in a separate thread.

      Note that on reception of the first view (a new member just joined), the channel will not yet be in the connected state. This only happens when `Channel.connect(String)` returns.
      Specified by:
        `viewAccepted` in interface `MembershipListener`

    - #### suspect

          public void suspect(Address suspected_mbr)

      Deprecated.
      Description copied from interface: `MembershipListener`
      Called whenever a member is suspected of having crashed, but has not yet been excluded.
      Specified by:
        `suspect` in interface `MembershipListener`

    - #### block

          public void block()

      Deprecated.
      Description copied from interface: `MembershipListener`
      Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages. Any messages sent after returning from this callback might get blocked by the FLUSH protocol. When the FLUSH protocol is done, and messages can be sent again, the FLUSH protocol will simply unblock all pending messages. If a callback for unblocking is desired, implement `ExtendedMembershipListener.unblock()`. Note that block() is the equivalent of reception of a BlockEvent in the pull mode.
      Specified by:
        `block` in interface `MembershipListener`

    - #### getCache

          public java.io.Serializable getCache()

      Deprecated.

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.